"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotCommandUploader = void 0;
class BotCommandUploader {
    constructor(api) {
        this.api = api;
    }
    async upload(list) {
        let commandList = list.get();
        for (let { language, commands: languageCommands } of commandList) {
            for (let { scope, bodies: commands } of languageCommands) {
                if (await this.checkActuality(language, commands, scope)) {
                    continue;
                }
                await this.api.callMethod("setMyCommands", {
                    commands,
                    scope,
                    language_code: language
                });
            }
        }
    }
    async checkActuality(lang, commands, scope) {
        let { result } = await this.api.callMethod("getMyCommands", {
            scope,
            language_code: lang
        });
        return result.length > 0 && result.every(resCmd => commands.some(cmd => cmd.command === resCmd.command && cmd.description === resCmd.description));
    }
}
exports.BotCommandUploader = BotCommandUploader;
